﻿------------------------------------------------------------------------------------------
--Cooldown Group Frame--------------------------------------------------------------------
------------------------------------------------------------------------------------------
local SN, L, F, T, M, _ = unpack(select(2,...))
local LSM = LibStub("LibSharedMedia-3.0")

local UnitInParty = UnitInParty
local UnitInRaid = UnitInRaid
local UnitGUID = UnitGUID
local GetInspectSpecialization = GetInspectSpecialization
local GetNumGroupMembers = GetNumGroupMembers
local GetSpellCooldown = GetSpellCooldown
local IsInInstance = IsInInstance

function SN:SetupCD()
	local SNd = SN.data.profile

	F.cooldowns = T:NewGroup(SNd.cooldown.width, "CD Frame", cooldowns, M.media.draghandle)
	F.cooldowns:SetSorting("SN:arg4")
	if(IsAddOnLoaded("ElvUI")) then
		F.cooldowns:SetSpacing(0, 7)
		F.cooldowns:SetStartPoint("bottomleft")
		F.cooldowns:SetPoint(unpack(SNd.Frames.elvcooldowns))
	else
		F.cooldowns:SetSpacing(0, 3)
		F.cooldowns:SetStartPoint("topleft")
		F.cooldowns:SetPoint(unpack(SNd.Frames.cooldowns))
	end
	F.cooldowns:SetScript("OnEvent", function(self, event, ...)
		SN:CooldownEvents(self, event, ...)
	end)
	
	--Register our events for the frame
	F.cooldowns:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	F.cooldowns:RegisterEvent("PLAYER_REGEN_DISABLED")
	F.cooldowns:RegisterEvent("SPELL_UPDATE_USABLE")
end

function SN:CooldownEvents(self, event, ...)
	local SNd = SN.data.profile

	if event == "COMBAT_LOG_EVENT_UNFILTERED" then
		local _, type, _, sourceGUID, sourceName, _, _, destGUID, destName = ...
		local spellId, spellName = select(12, ...)
				
		if type == "SPELL_CAST_SUCCESS" then
			if UnitInParty(sourceName) or UnitInRaid(sourceName) or (sourceGUID == UnitGUID("player")) then
				for i, cooldown in pairs(SNd.cooldowns) do
					if spellId == cooldown.id then
						if cooldown.enable then
						--Check to see if the cd is a personal only and also if it is enable
							if SNd.CD.raid then
								if UnitInParty(sourceName) or UnitInRaid(sourceName) then -- or (sourceGUID == UnitGUID("player")) then
									--SN:Debug(frame.name)
									local modCD
									if spellId == 740 and GetInspectSpecialization(sourceName) == 105 then
										modCD = 180
									else
										modCD = cooldown.CD
									end
									SN:CreateBar(self, spellId, modCD, sourceName, sourceGUID, spellName, 
										SNd.cooldown.width, SNd.cooldown.height, SNd.cooldown.fontsize, LSM:Fetch("font", SNd.cooldown.font))
										
									local bit
									if GetNumGroupMembers() > 5 and IsInRaid() then
										bit = true
									elseif GetNumGroupMembers() > 1 and not IsInRaid() then
										bit = false
									end
									SN:Announcer(self, modCD, spellId, sourceName, destName, bit)
								end
							elseif sourceGUID == UnitGUID("player") then
								local modCD
								if spellId == 740 and GetInspectSpecialization(sourceName) == 105 then
									modCD = 180
								else
									modCD = cooldown.CD
								end
								if sourceGUID == UnitGUID("player") and cooldown.class == select(2, UnitClass("player")) then
									SN:CreateBar(self, spellId, modCD, sourceName, sourceGUID, spellName, 
										SNd.cooldown.width, SNd.cooldown.height, SNd.cooldown.fontsize, LSM:Fetch("font", SNd.cooldown.font))
								end
							end
						end
					end
				end
			end
		elseif type == "UNIT_DIED" or "UNIT_DESTROYED" then
		--Check for a wipe so we can kill the cooldown bars
			local inInstance, instanceType = IsInInstance()
			if (inInstance and instanceType == "raid" or "party") and GetNumGroupMembers() > 1 then
				local wiped = SN:CheckForWipe()
				if wiped then
					for i, bar in pairs(self.bars) do
						if i:GetData("SN:arg7") > 299 then
							i:Stop()
						end
					end
				end
			end
		end
	end
	if event == "SPELL_UPDATE_USABLE" then
			
		local i = self:Find("SN:arg4", "player")
		if i ~= nil then
			local _, duration, enable = GetSpellCooldown(i:Get("SN:arg2"))
			if duration == 0 then
				i:Stop()
			end
		end
	end
end